//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------

#include "util.h"
#include <AppEvnts.hpp>

class TMyTank;

class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *pnlView;
        TPaintBox *pbxView;
        TMainMenu *mnuMain;
        TMenuItem *mnuGame;
        TMenuItem *mnuStartGame;
        TMenuItem *mnuRestart;
        TMenuItem *N2;
        TMenuItem *mnuChooseLevel;
        TMenuItem *N3;
        TMenuItem *mnuPrevLevel;
        TMenuItem *mnuNextLevel;
        TMenuItem *N1;
        TMenuItem *mnuExit;
        TMenuItem *M1;
        TMenuItem *mnuSuperMode;
        TMenuItem *mnuUnlimitedBullet;
        TMenuItem *N4;
        TMenuItem *mnuDrawLayer1;
        TMenuItem *mnuDrawLayer2;
        TMenuItem *mnuDrawLayer3;
        TMenuItem *mnuDrawLayer4;
        TMenuItem *mnuHelp;
        TMenuItem *mnuAbout;
        TTimer *tmrTitle;
        TApplicationEvents *ApplicationEvents1;
        void __fastcall tmrTitleTimer(TObject *Sender);
        void __fastcall pbxViewPaint(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall mnuStartGameClick(TObject *Sender);
        void __fastcall mnuRestartClick(TObject *Sender);
        void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall mnuAboutClick(TObject *Sender);
        void __fastcall mnuChooseLevelClick(TObject *Sender);
        void __fastcall mnuPrevLevelClick(TObject *Sender);
        void __fastcall FormKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall mnuSuperModeClick(TObject *Sender);
        void __fastcall mnuDrawLayerClick(TObject *Sender);
        void __fastcall mnuExitClick(TObject *Sender);
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall ApplicationEvents1Message(tagMSG &Msg,
          bool &Handled);
private:	// User declarations
  enum TGameStatus {gsTitle, // we
                 gsPlaying,  // Ci椤
                 gsSuccess,  // Le
                 gsOver,     // GAME OVER
                 gsTerminate}; // {YN

  TGameStatus FGameStatus; // CA
  int FLevelNo; // ثed
  TMyTank* FTank; // D
  int FETankUsed; // dwX{ĤZJ
  int FScore; // 
  bool FEnemyStopped; // O_ȰĤ

  Graphics::TBitmap* FBackBitmap; // ΨӰ dobule-buffering  bitmap

  void __fastcall DrawBackBitmap(); // øsI bitmap
  void __fastcall UpdateView(); // sCe
  void __fastcall UpdateControlStatus();

  // ͼĤZJ_
  void __fastcall CreateETank(int Kind);
  void __fastcall CreateGem(int Kind);

  void __fastcall InitLevel(); // d}lelʧ@
  void __fastcall GameLoop(); // CDj

  // bCeΥWøXrΥ~
  void __fastcall DrawStatusBox(AnsiString S, bool TopOrCenter);

  void __fastcall SetGameStatus(TGameStatus Value);
  void __fastcall SetLevelNo(int Value);

  __property TGameStatus GameStatus = {read = FGameStatus, write = SetGameStatus};
  __property int LevelNo = {read = FLevelNo, write = SetLevelNo};
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
