//---------------------------------------------------------------------------

#ifndef utilH
#define utilH
//---------------------------------------------------------------------------

#undef VAR
#undef INI

#ifdef utilCPP
#define VAR
#define INI(x) = x
#else
#define VAR extern
#define INI(x)
#endif

// aϤlt

#define TILE_NUM_X 13                                // eb
#define TILE_NUM_Y 13                                // eab

#define TILE_WIDTH 32                                // ϤeI
#define TILE_HEIGHT 32                               // ϤI

#define SM_TILE_NUM_X 4
#define SM_TILE_NUM_Y 4

#define SM_TILE_WIDTH  (TILE_WIDTH / SM_TILE_NUM_X)  // pHeI
#define SM_TILE_HEIGHT (TILE_HEIGHT / SM_TILE_NUM_X) // pHI

#define WORLD_WIDTH    (TILE_WIDTH * TILE_NUM_X)     // ee
#define WORLD_HEIGHT   (TILE_HEIGHT * TILE_NUM_Y)    // e

VAR const char* SIG_MYFILE   INI("Xshadow_Stock");   // ϮwΦaɮתY

VAR const char* FN_TILE_ARCHIVE   INI("TILES.TIA");  // Ϯwɮ

VAR const char* FN_MAP_PREFIX     INI("MAP");        // dɦW (MAP??.DAT)
VAR const char* FN_MAP_EXT        INI(".DAT");       // dɰɦW

VAR const int& LAYER_TERR          INI(0);            // aμh
VAR const int& LAYER_TERRITEM      INI(1);            // aΪh
VAR const int& LAYER_ITEM          INI(2);            // ~h
VAR const int& LAYER_HITERRITEM    INI(3);            // aΪh

#define LAYER_MAX 3                                  // ̦h찪aΪh

// lt
VAR const char* DR_IMAGES         INI("img\\");       // vɪsؿ

VAR const int& SPRITE_DEFAULT_SPEED   INI(4);         // ⪺w]t
VAR const int& SMOOTH_MOVE_THRESHOLD
      INI(SPRITE_DEFAULT_SPEED * 3 - 1);             // Ʋʪe

VAR const int& MYTANK_DEFAULT_SPEED      INI(5);      // ڤZJw]t
VAR const int& BULLET_DEFAULT_SPEED      INI(10);     // luw]t
VAR const int& BULLET_DEFAULT_BLOW_RANGE INI(4);      // luw]zd

VAR const int& MAX_ETANK_PER_SCENARIO    INI(20);     // CDdĤZJƥ
VAR const int& MAX_TANK_ON_SCREEN        INI(5);      // eW̦hZJƥ
VAR const int& MAX_ETANK_COLLISION_COUNT INI(5);      // ĤZJsIƤW

VAR const float& PROBAB_ETANK_SHOT_BULLET  INI(0.1);    // ĤZJgluv
VAR const float& PROBAB_ETANK_RANDOM_TURN  INI(0.02);   // ĤZJHNsv
VAR const float& PROBAB_ETANK_BORN         INI(0.02);   // ĤZJX;v
VAR const float& PROBAB_GEM_BORN           INI(0.005);  // _X{v

#define TIMER_ID_GEM                     1            // _ͷҨϥΪ Timer s
#define TIMER_ID_GEM_CLOCK               2            // _ĪGҨϥΪ Timer s
#define TIMER_ID_GEM_HAT                 3            // Ul_ĪGҨϥΪ Timer s
#define TIMER_ID_GEM_ARROW               4            // }b_ĪGҨϥΪ Timer s

// ǻCDj骺Ts
#define WM_DESTROY_OBJECT        (WM_USER + 0)      // RO
#define WM_GAMEOVER              (WM_USER + 1)      // CT
#define WM_SPECIAL_CONDITION     (WM_USER + 2)      // Y_ɲͮĪGO
#define WM_INIT_LEVEL            (WM_USER + 3)      // ds}l

VAR TColor TRANSPARENT_COLOR      INI((TColor)RGB(0, 0, 0));
VAR TRect TILE_RECT               INI(Classes::Rect(0, 0, TILE_WIDTH, TILE_HEIGHT));
VAR TRect SM_TILE_RECT            INI(Classes::Rect(0, 0, SM_TILE_WIDTH, SM_TILE_HEIGHT));

// `ƪܼ, ǥ util_init() Ӷil
// g`p⪺k, ҥHت => dk
VAR int TILEWIDTH[TILE_NUM_X + 1];
VAR int TILEHEIGHT[TILE_NUM_Y + 1];

VAR int SM_TILEWIDTH[SM_TILE_NUM_X + 1];
VAR int SM_TILEHEIGHT[SM_TILE_NUM_Y + 1];

VAR void util_init();
VAR void CheckSignature(TReader* reader, const AnsiString Sig);

#endif

